#!/usr/bin/env python

# /* ***** BEGIN LICENSE BLOCK *****
#  * Version: MPL 1.1
#  *
#  * The contents of this file are subject to the Mozilla Public License Version
#  * 1.1 (the "License"); you may not use this file except in compliance with
#  * the License. You may obtain a copy of the License at
#  * http://www.mozilla.org/MPL/
#  *
#  * Software distributed under the License is distributed on an "AS IS" basis,
#  * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
#  * for the specific language governing rights and limitations under the
#  * License.
#  *
#  * The Original Code is the Suffix Array based String Kernel.
#  *
#  * The Initial Developer of the Original Code is
#  * Statistical Machine Learning Program (SML), National ICT Australia (NICTA).
#  * Portions created by the Initial Developer are Copyright (C) 2006
#  * the Initial Developer. All Rights Reserved.
#  *
#  * Contributor(s):
#  *
#  *   Choon Hui Teo <ChoonHui.Teo@rsise.anu.edu.au>
#  *   S V N Vishwanathan <SVN.Vishwanathan@nicta.com.au>
#  *
#  * ***** END LICENSE BLOCK ***** */


#  File    : sask/Code/plot-fixedtext.py
#  Authors : Choon Hui Teo      (ChoonHui.Teo@rsise.anu.edu.au)
#            S V N Vishwanathan (SVN.Vishwanathan@nicta.com.au)
#  Created :    Feb 2006
#  Updated : 24 Apr 2006



#'SA := Suffix Arrays
#'ST := Suffix Trees

#Plot fixed text kernel evaluation time of SA with and
#without suffix link run on gutenberg datasets.



import matplotlib.matlab as mp

mp.figure(figsize=(4, 3), frameon=False)
mp.axes([0.2, 0.2, 0.73, 0.75])

#' load data
sa_sl  = mp.load('fixedtext-runtime-sa-sl.log')
sa_nsl = mp.load('fixedtext-runtime-sa-nsl.log')


sa_sl[:,0]  = [x/1024.0 for x in sa_sl[:,0]]
sa_nsl[:,0] = [x/1024 for x in sa_nsl[:,0]]

    
#' plot data
mp.figure(1)
mp.loglog(sa_sl[:,0],sa_sl[:,1],'bo-', linewidth=2)
mp.loglog(sa_nsl[:,0],sa_nsl[:,1],'g>-.', linewidth=2)


# mp.title('kernel evaluation time')
mp.legend(('SA_SL','SA-NSL'), loc=(0.05, 0.6))
mp.xlabel('Pattern size (KB)')
mp.ylabel('Time (ms)')

#mp.gca().set_ylim((60, 10000))
mp.savefig("FixedText.png")
mp.show()

