#!/usr/bin/env python

# /* ***** BEGIN LICENSE BLOCK *****
#  * Version: MPL 1.1
#  *
#  * The contents of this file are subject to the Mozilla Public License Version
#  * 1.1 (the "License"); you may not use this file except in compliance with
#  * the License. You may obtain a copy of the License at
#  * http://www.mozilla.org/MPL/
#  *
#  * Software distributed under the License is distributed on an "AS IS" basis,
#  * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
#  * for the specific language governing rights and limitations under the
#  * License.
#  *
#  * The Original Code is the Suffix Array based String Kernel.
#  *
#  * The Initial Developer of the Original Code is
#  * Statistical Machine Learning Program (SML), National ICT Australia (NICTA).
#  * Portions created by the Initial Developer are Copyright (C) 2006
#  * the Initial Developer. All Rights Reserved.
#  *
#  * Contributor(s):
#  *
#  *   Choon Hui Teo <ChoonHui.Teo@rsise.anu.edu.au>
#  *   S V N Vishwanathan <SVN.Vishwanathan@nicta.com.au>
#  *
#  * ***** END LICENSE BLOCK ***** */


#  File    : sask/Code/plot-ltp.py
#  Authors : Choon Hui Teo      (ChoonHui.Teo@rsise.anu.edu.au)
#            S V N Vishwanathan (SVN.Vishwanathan@nicta.com.au)
#  Created :    Feb 2006
#  Updated : 24 Apr 2006


#Plot linear time and direct prediction time of SA with and
#without suffix link run on gutenberg datasets.

#' The log files are formatted in this way:
#' # of SVs |  time (in milliseconds)


import matplotlib.matlab as mp

mp.figure(figsize=(4, 3), frameon=False)
mp.axes([0.2, 0.2, 0.73, 0.75])


#' === Load data ===
direct = mp.load('direct-alltime-sa-nsl.log')
sa_nsl = mp.load('ltp-alltime-sa-nsl.log')
sa_sl  = mp.load('ltp-alltime-sa-sl.log')


#' === Plot data ===
mp.figure(1)
mp.loglog(sa_sl[:,0],sa_sl[:,1], 'bo-', linewidth=2)
mp.loglog(sa_nsl[:,0],sa_nsl[:,1], 'g>-.', linewidth=2)
mp.loglog(direct[:,0],direct[:,1], 'kd', linewidth=2)


# mp.title('Linear-time prediction')
mp.xlabel('No. of Support Vectors')
mp.ylabel('Time (ms)')
mp.legend(('SA-SL', 'SA-NSL', 'Direct Method'), loc=(0.05, 0.70))

mp.gca().set_ylim((100, 4000000))
mp.savefig("LinearTime.png")
mp.show()

